<template>
  <div>
    <v-row>
      <v-col cols="2">
        <div v-if="hasInTime && fromTime">
          in: {{ timeFromSecondes(fromTime) }}
        </div>
      </v-col>
      <v-col cols="2">
        <div v-if="hasOutTime && fromTime">
          out: {{ timeFromSecondes(outTimeValue) }}
        </div>
      </v-col>
      <v-col cols="8">
        <LocationAutoComplete v-model="model.location" :label="label">
        </LocationAutoComplete>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import LocationAutoComplete from './LocationAutoComplete.vue';
import { timeFromSecondes } from '../shuttlingService';
import { mapGetters } from 'vuex';

export default {
  name: 'station-point',
  components: { LocationAutoComplete },
  props: {
    fromTime: {
      type: [Number],
      default: 0,
    },
    label: {
      type: [String],
      default: 'label',
    },
    value: {
      type: [Object],
      default: () => ({
        location: null,
        inTime: null,
        outTime: null,
      }),
    },
    hasInTime: {
      type: [Boolean],
      default: true,
    },
    hasOutTime: {
      type: [Boolean],
      default: true,
    },
    shouldAddStopTime: {
      type: [Boolean],
      description:
        'if it was first trip the starting point no need for addition',
      default: true,
    },
  },
  computed: {
    ...mapGetters('config', ['getDurationBetweenTripRuns', 'getStopDuration']),
    outTimeValue() {
      if (this.shouldAddStopTime === false) return this.fromTime;
      else return this.fromTime + this.getStopDuration;
    },
    model: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit('input', value);
      },
    },
  },
  data: function () {
    return {};
  },
  methods: {
    timeFromSecondes,
  },
};
</script>

<style lang="scss" scoped></style>
